/* NiuTrans.Tensor - an open-source tensor library
 * Copyright (C) 2018, Natural Language Processing Lab, Northestern University.
 * All rights reserved.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

/*
 * $Created by: XIAO Tong (xiaotong@mail.neu.edu.cn) 2018-07-10
 */

#include <stdio.h>
#include "XNet.h"
#include "../tensor/XUtility.h"
#include "../tensor/function/FHeader.h"
#include "../tensor/core/CHeader.h"
#include "../sample/fnnlm/FNNLM.h"

//#define CRTDBG_MAP_ALLOC
//#include <stdlib.h>
//#include <crtdbg.h>

using namespace nts;
using namespace samplefnnlm;

int main( int argc, const char ** argv )
{
    if(argc > 1 && !strcmp(argv[1], "-test"))
        1;//Test();
    else if(argc > 1 && !strcmp(argv[1], "-fnnlm"))
        FNNLMMain(argc - 1, argv + 1);
    else{
        fprintf(stderr, "Thanks for using NiuTrans.Network! This is a library for building\n");
        fprintf(stderr, "neural networks in an easy way. \n\n");
        fprintf(stderr, "Run this program with \"-test\" for unit test!\n");
        fprintf(stderr, "Or run this program with \"-fnnlm\" for sample FNNLM!\n");
    }

    return 0;

    XNet net;
    XTensor a;
    XTensor b;
    XTensor c;

    InitTensor2D(&a, 2, 2);
    InitTensor2D(&b, 2, 4);
    InitTensor2D(&c, 2, 4);

    a.SetZeroAll();
    b.SetZeroAll();
    c.SetZeroAll();

    SetDataFixed(a, 0.1F);
    a.Set2D(0.3F, 1, 0);
    a.Set2D(0.4F, 1, 1);

    b = Merge(a, a, 1);
    c = HTanH(MMul(a, b));

    a.Dump(stderr, "a:");
    b.Dump(stderr, "b:");
    c.Dump(stderr, "c:");
    XLink::ShowNetwork(stderr, &c);

    net.Backward(c);

    net.Dump(stderr);
    
    //_CrtDumpMemoryLeaks();
    
    return 0;
}
